<?php

namespace Modules\Fo\Http\Controllers;

use Illuminate\Contracts\Support\Renderable;
use Illuminate\Http\Request;
use Illuminate\Routing\Controller;
use Illuminate\Support\Facades\DB;

class VisitPlanCalanderController extends Controller
{
    function loadVisitPlanToCalander($filed_officer_id, $start_date, $end_date)
    {
        try {
            $query = 'SELECT st_suppliers.supplier_name,st_products.product_id,st_products.product_name,fo_plan_product_employee_dailies.quantity,fo_plan_product_employee_dailies.date AS start_date,fo_plan_product_employee_dailies.date AS end_date FROM fo_plan_product_employee_dailies
            INNER JOIN st_products ON fo_plan_product_employee_dailies.product_primary_id = st_products.product_primary_id
            INNER JOIN st_suppliers ON fo_plan_product_employee_dailies.supplier_id = st_suppliers.supplier_id  WHERE fo_plan_product_employee_dailies.field_officer_id = "' . $filed_officer_id . '"  AND fo_plan_product_employee_dailies.date BETWEEN "' . $start_date . '" AND "' . $end_date . '"';
            $result = DB::select($query);
            $responseBody = $this->responseBody(true, "VisitPlanCalanderController", "loadVisitPlanToCalander", $result);
        } catch (\Exception $ex) {
            $responseBody = $this->responseBody(false, "VisitPlanCalanderController", "error", $ex);
        }
        return response()->json(["data" => $responseBody]);
    }

    /**
     * responseBody
     * This is used to create response.
     * @param success This is the paramter require boolean
     * @param name This is the paramter require ui table name
     * @param message This is the paramter require message content
     * @param result This is the paramter require result as some of data to return client
     * @return Json This returns as response.
     */
    private function responseBody($success, $name, $message, $result)
    {
        $body = [
            "success" => $success,
            "message" => $message,
            "name" => $name,
            "result" => $result
        ];
        return $body;
    }
}
