console.log('producttion_plan_calender.js')

var events = [];

$(document).ready(function () {
    $('#calendar-demo').fullCalendar({
        header: {
            left: 'prev,next today',
            center: 'title',
            right: 'month,agendaWeek,agendaDay,listMonth'
        },
        editable: true,
        droppable: true,
        drop: function () {
            $(this).remove();

        },
        weekNumbers: true,
        eventLimit: false, // allow "more" link when too many events
        dayClick: function () {
            $('#createEventModal').modal();

        },
        eventClick: function (event, jsEvent, view) {
            var product_id = event.description.product_id;
            var quantity = event.description.quantity;
            var product_name = event.description.product_name;
            var supplier = event.description.supplier;

            var html = '';
            html += '<table class="table table-striped">';
            html += '<thead>';
            html += '<tr>';
            html += '<th>Product ID</th><th>Product Name</th> <th>Quantity</th><th>Supplier</th>';
            html += '</tr>';
            html += '</thead>';
            html += '<tbody>';
            html += '<tr>';
            html += '<td>' + product_id + '</td>';
            html += '<td>' + product_name + '</td>';
            html += '<td>' + quantity + '</td>';
            html += '<td>' + supplier + '</td>';
            html += '</tr>';
            html += '</tbody>';
            html += '</table>';

            var modal = $('#viewEventModal');
            modal.find('.event-body').html(html);
            modal.find('.event-icon').html("<i class='fa fa-" + event.icon + "'></i>");
            modal.find('.event-title').html(event.title);
            modal.modal();
        },
    });

    loadVisitCalanderPlan();

});

function loadVisitCalanderPlan() {

    clearCalander();

    var officer_id = $('#auto-comp1').optionID();
    var startDate = $('#dashboard-daterangepicker').data('daterangepicker').startDate.format('YYYY-MM-DD');
    var endDate = $('#dashboard-daterangepicker').data('daterangepicker').endDate.format('YYYY-MM-DD');

    $.ajax({
        type: 'GET',
        url: '/fo/VisitPlanCalanderController/loadVisitPlanToCalander/' + officer_id + "/" + startDate + "/" + endDate,
        success: function (response) {
            if (response.data.success) {
                console.log(response);

                for (i = 0; i < response.data.result.length; i++) {
                    var end_date = response.data.result[i]['end_date'];
                    var start_date = response.data.result[i]['start_date'];
                    var product_name = response.data.result[i]['product_name'];
                    var product_id = response.data.result[i]['product_id'];
                    var quantity = response.data.result[i]['quantity'];
                    var supplier = response.data.result[i]['supplier_name'];
                    var newend_date = end_date.substring(0, 10);
                    var newstart_date = start_date.substring(0, 10);

                    // console.log(newDate);
                    addShedule(product_id, product_name, newstart_date, newend_date, quantity, supplier);
                }
                createCalendar();
            }

        }, error: function (data) {
            console.log('Something went wrong!');
        }
    })
}



function addShedule(product_id, product_name, newstart_date, newend_date, quantity, supplier) {




    var R = (parseInt(product_id) * 215);
    while (R > 255) { R = R - 100 }
    var G = (parseInt(product_id) * 100);
    while (G > 255) { G = G - 50 }
    var B = (parseInt(product_id) * 50);
    while (B > 255) { B = B - 50 }



    events.push({
        title: product_name,
        start: newstart_date,
        end: newend_date,
        backgroundColor: 'rgb(' + R + ',' + G + ',' + B + ')',
        icon: "building-o",
        description: { "product_id": product_id, "date": newstart_date, "quantity": quantity, 'product_name': product_name, "supplier": supplier },
    });

}


function clearCalander() {
    // alert();
    $('#calendar-demo').fullCalendar('removeEvents');
    events = [];
}


function createCalendar() {
    $('#calendar-demo').fullCalendar('removeEvents');
    $('#calendar-demo').fullCalendar('addEventSource', events);

}
